//+------------------------------------------------------------------------------------------+
//|                                                                         DailyData.mq4    |
//|                                                                                mladen    |
//|   Version: DailyData_v01.mq4   by okfar (forex-tsd forum nick)                           |
//|         - add changable fontsize                                                         |
//|         - add changable distance from top                                                |
//|         - add ADX indicator (timeframe: MN1 - Monthly, W1-Weekly, D1-Daily, H4-4 hour)   |                                                                    
//+------------------------------------------------------------------------------------------+
#property copyright "mladen"
#property link      "mladenfx@gmail.com"

#property indicator_chart_window
#property indicator_buffers 4
#property indicator_color1  Green
#property indicator_color2  Maroon
#property indicator_color3  Lime
#property indicator_color4  Red
#property indicator_width1  1
#property indicator_width2  1
#property indicator_width3  2
#property indicator_width4  2

//
//
//
//
//

extern color zoneColor      = C'30,33,36';
extern int   CandleShift    = 8;
extern bool  ShowInfo       = True;
extern bool  ShowSwap       = True;
extern bool  ShowBackground = True;
extern bool  ShowBar        = True;
//
extern bool    ShowADX      = True;          //ON = True, OFF = False
extern int     periodADX    = 14;            //Averaging period for calculation.
extern int     appPriceADX  = PRICE_CLOSE;   //Applied price:   PRICE_CLOSE = 0, PRICE_OPEN =1, ...... 
extern int     modeADX      = MODE_MAIN;     //Indicator line index: MODE_MAIN =0 (Base indicator line.),  MODE_PLUSDI = 1 (+DI indicator line.), ....


extern int y   = 0;                          //verical distance from top                   
extern int fontsize=  10;                    //Font size

//
//
//
//
//

double DayHigh[];
double DayLow[];
double DayOpen[];
double DayClose[];
double prevCurr =-1;
int    DataPeriod;
int    DataBar;
string indNames = "DailyData";
double dy=0,
    dx=0;
int y2;
//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+

int init()
{
   SetIndexBuffer(0, DayHigh);
   SetIndexBuffer(1, DayLow);
   SetIndexBuffer(2, DayClose);
   SetIndexBuffer(3, DayOpen);
      if (ShowBar)
         for (int i=0;i<4;i++)
            {
               SetIndexStyle(i,DRAW_HISTOGRAM);
               SetIndexShift(i,CandleShift);
               SetIndexLabel(i,"Daily data");
            }            
      else  for (i=0;i<4;i++) SetIndexStyle(i,DRAW_NONE);

   //
   //
   //
   //
   //
            
   switch(Period())
   {
      case PERIOD_MN1:
      case PERIOD_W1:  DataPeriod = PERIOD_MN1; break;
      case PERIOD_D1:  DataPeriod = PERIOD_W1;  break;
      default:         DataPeriod = PERIOD_D1;
   }
   prevCurr = -1;
   
   dy=(fontsize/10.0);
   dx=(fontsize/15.0);
   
   return(0);
}
int deinit()
{
   for (int counter=-1;counter<25;counter++) ObjectDelete(indNames+counter);
   return(0);
}


//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+

int start()
{
   int    digits   = MarketInfo(Symbol(),MODE_DIGITS);
   double modifier = 1;
   
      if (digits==3 || digits==5) modifier = 10.0;
      else 
            if (ObjectFind(indNames+"24") != -1)
                ObjectDelete(indNames+"24");
      
      //
      //
      //
      //
      //
            
      DataBar  = iBarShift(NULL,DataPeriod,Time[0]);
         double HiDAILY  = iHigh (NULL,DataPeriod,DataBar);
         double LoDAILY  = iLow  (NULL,DataPeriod,DataBar); 
         double current  = iClose(NULL,DataPeriod,DataBar);
         double range    = getRange(DataPeriod)/modifier;
         double change   = (current-iOpen(NULL,DataPeriod,DataBar))/(Point*modifier);
         int    limit,i;
      
      //
      //
      //
      //
      //

      if (ShowInfo)
      {
          if (ObjectFind(indNames+"1") ==-1) {
                  objectCreate("1",10*dx,(10+y)*dy,"-------------------------------------",fontsize,NULL);  
                  objectCreate("3",60*dx,(32+y)*dy,"distance from high : ",fontsize);
                  objectCreate("4",60*dx,(44+y)*dy,"distance from low : " ,fontsize);
                  objectCreate("5",10*dx,(56+y)*dy,"-------------------------------------",fontsize,NULL);
                     if (ShowSwap)
                     {
                        objectCreate("2",60*dx,(20+y)*dy,"change/range : ",fontsize);
                        objectCreate("6",60*dx,(64+y)*dy,"swap long : "         ,fontsize);
                        objectCreate("7",60*dx,(76+y)*dy,"swap short : "        ,fontsize);
                        objectCreate("8",10*dx,(84+y)*dy,"--------------------------------------",fontsize,NULL);  
                     }
                     else
                     {
                        objectCreate("2",60*dx,(20+y)*dy,"range : "       ,fontsize);
                        objectCreate("6",60*dx,(64+y)*dy,"distance from open : ",fontsize);
                        objectCreate("8",10*dx,(76+y)*dy,"---------------------------------------",fontsize,NULL);  
                     }                     
         }

         //
         //
         //
         //
         //

         if (prevCurr != current)
            {
               prevCurr = current;
                  double currFromHi = (HiDAILY-current)/(Point*modifier);
                  double currFromLo = (current-LoDAILY)/(Point*modifier);

                  //
                  //
                  //
                  //
                  //
                  
                     objectCreate("0",128*dx,(0+y)*dy,Symbol(),fontsize,"Arial bold",YellowGreen);  
                     if (ShowSwap)
                           objectCreate("10",10*dx,(20+y)*dy,DoubleToStr(change,0)+"/"+DoubleToStr(range,0)    ,fontsize,"Arial bold",Gold);
                     else  objectCreate("10",10*dx,(20+y)*dy,                          DoubleToStr(range,0)    ,fontsize,"Arial bold",Gold);
                     objectCreate("11",10*dx,(32+y)*dy,DoubleToStr(currFromHi,0)                         ,fontsize,"Arial bold",YellowGreen);
                     objectCreate("12",10*dx,(44+y)*dy,DoubleToStr(currFromLo,0)                         ,fontsize,"Arial bold",YellowGreen);
                     if (ShowSwap)
                     {
                        objectCreate("13",10*dx,(64+y)*dy,DoubleToStr(MarketInfo(Symbol(),MODE_SWAPLONG),2) ,fontsize,"Arial bold",YellowGreen);
                        objectCreate("14",10*dx,(76+y)*dy,DoubleToStr(MarketInfo(Symbol(),MODE_SWAPSHORT),2),fontsize,"Arial bold",YellowGreen);
                     }
                     else
                     {
                        if (change<0)
                              objectCreate("13",10*dx,(64+y)*dy,DoubleToStr(change,0) ,fontsize,"Arial bold",Red);
                        else  objectCreate("13",10*dx,(64+y)*dy,DoubleToStr(change,0) ,fontsize,"Arial bold",Gold);
                     }
                  string currentValue = DoubleToStr(current,digits);                  
                     objectCreate("15",10*dx, (0+y)*dy,currentValue,fontsize+2,"Arial bold",YellowGreen);  
                     if (modifier !=1)
                        objectCreate("16",10*dx, (0+y)*dy,StringSubstr(currentValue,StringLen(currentValue)-1),fontsize+2,"Arial bold",Gold);  
            
            if (ShowADX) {
               if (ShowSwap)
                  y2=84;
               else 
                  y2=76;
                  
               objectCreate("17",60*dx,(y2+12+y)*dy,"ADX MN1: ",fontsize);
               objectCreate("18",10*dx,(y2+12+y)*dy, DoubleToStr(iADX(Symbol(), PERIOD_MN1, periodADX, appPriceADX,  modeADX, 0),2), fontsize,  "Arial bold",YellowGreen); 
               objectCreate("19",60*dx,(y2+24+y)*dy," ADX W1 : ",fontsize);
               objectCreate("20",10*dx,(y2+24+y)*dy, DoubleToStr(iADX(Symbol(), PERIOD_W1, periodADX, appPriceADX,  modeADX, 0),2), fontsize,  "Arial bold",YellowGreen);
               objectCreate("21",60*dx,(y2+36+y)*dy," ADX D1 : ",fontsize);
               objectCreate("22",10*dx,(y2+36+y)*dy, DoubleToStr(iADX(Symbol(), PERIOD_D1, periodADX, appPriceADX,  modeADX, 0),2), fontsize,  "Arial bold",YellowGreen);
               objectCreate("23",60*dx,(y2+48+y)*dy," ADX H4 : ",fontsize,NULL);
               objectCreate("24",10*dx,(y2+48+y)*dy, DoubleToStr(iADX(Symbol(), PERIOD_H4, periodADX, appPriceADX,  modeADX, 0),2), fontsize,  "Arial bold",YellowGreen);  
                
            }
            
            
            }   
      }           
      setBarIndicator(change,HiDAILY,LoDAILY,iOpen(NULL,DataPeriod,DataBar),current);
      for(i=0,limit=Bars-1;i<4;i++) SetIndexDrawBegin(i,limit); 
   return(0);
  }

//+------------------------------------------------------------------+
//+------------------------------------------------------------------+  
//
//
//
//
//

void setBarIndicator(double change, double hi,double low, double open, double close)
{
   string name  = indNames+"-1";
   int    shift = 0;
   
   if (change>0) { DayHigh[shift]  = hi;  DayLow[shift] = low; }            
   else          { DayHigh[shift]  = low; DayLow[shift] = hi;  }            
                   DayOpen[shift]  = open;
                   DayClose[shift] = close;

   if (ShowBackground)
      {                         
         if (ObjectFind(name) == -1)
             ObjectCreate(name,OBJ_RECTANGLE,0,0,0);
             ObjectSet(name,OBJPROP_TIME1,iTime(NULL,DataPeriod,DataBar));
             ObjectSet(name,OBJPROP_TIME2,iTime(NULL,         0,0));
             ObjectSet(name,OBJPROP_PRICE1,hi);
             ObjectSet(name,OBJPROP_PRICE2,low);
             ObjectSet(name,OBJPROP_COLOR,zoneColor);
      }             
}

//
//
//
//
//

double getRange(int period)
{
      double range = iHigh(NULL, period, DataBar) - iLow(NULL, period, DataBar);
      return (NormalizeDouble(range/Point,0));
}

//
//
//
//
//

void objectCreate(string name,int x,int y,string text="-",int size=10,
                  string font="Arial",color colour=DimGray,int window = 0)
{
   if (ObjectFind(indNames+name) == -1)
   {
      ObjectCreate(indNames+name,OBJ_LABEL,window,0,0);
         ObjectSet(indNames+name,OBJPROP_CORNER,1);
         ObjectSet(indNames+name,OBJPROP_XDISTANCE,x);
         ObjectSet(indNames+name,OBJPROP_YDISTANCE,y);
   }               
   ObjectSetText(indNames+name,text,size,font,colour);
}